Subject: Re: [patch 1/2]d80211: hardware TKIP support for ipw3945

From: Jouni Malinen <[email-masked]>
Date: Thu, 16 Nov 2006 09:40:53 -0800

On Thu, Nov 16, 2006 at 06:38:20PM +0100, Johannes Berg wrote:

> Oh, good point. Will need to think about this more. But right now, if
> that MMIC flag is set (i.e. hw does MMIC), we still do MMIC for
> fragmented frames. And there's actually a bug here I think: if hw does
> MMIC, how can the driver tell not to do it on those frames it's getting
> as fragments?

It's been awhile since I working on this part, but if I remember
correctly, this can be done easily by the driver behaving different
based on the frame being fragmented or not (it is fragmented if MoreFrag
flag is set or seq# != 0). That's the way it was done with hardware
designs that allow full TKIP hwaccel for MSDUs that are not fragmented,
but require software implementation of Michael MIC if MSDU is
fragmented.

-- 
Jouni Malinen                                            PGP id EFC895FA